.386
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include ole32.inc
includelib ole32.lib
include shell32.inc
includelib shell32.lib

include csidls.inc

;**********************************************************************************************************

.data
listy   dd CSIDL_DESKTOP,OFFSET desktop_str
        dd CSIDL_INTERNET,OFFSET internet_str
        dd CSIDL_PROGRAMS,OFFSET programs_str
        dd CSIDL_CONTROLS,OFFSET controls_str
        dd CSIDL_PRINTERS,OFFSET printers_str
        dd CSIDL_PERSONAL,OFFSET personal_str
        dd CSIDL_FAVORITES,OFFSET favorites_str
        dd CSIDL_STARTUP,OFFSET startup_str
        dd CSIDL_RECENT,OFFSET recent_str
        dd CSIDL_SENDTO,OFFSET sendto_str
        dd CSIDL_BITBUCKET,OFFSET bitbucket_str
        dd CSIDL_STARTMENU,OFFSET startmenu_str
        dd CSIDL_MYDOCUMENTS,OFFSET mydocuments_str
        dd CSIDL_MYMUSIC,OFFSET mymusic_str
        dd CSIDL_MYVIDEO,OFFSET myvideo_str
        dd CSIDL_DESKTOPDIRECTORY,OFFSET desktopdirectory_str
        dd CSIDL_DRIVES,OFFSET drives_str
        dd CSIDL_NETWORK,OFFSET network_str
        dd CSIDL_NETHOOD,OFFSET nethood_str
        dd CSIDL_FONTS,OFFSET fonts_str
        dd CSIDL_TEMPLATES,OFFSET templates_str
        dd CSIDL_COMMON_STARTMENU,OFFSET common_startmenu_str
        dd CSIDL_COMMON_PROGRAMS,OFFSET common_programs_str
        dd CSIDL_COMMON_STARTUP,OFFSET common_startup_str
        dd CSIDL_COMMON_DESKTOPDIRECTORY,OFFSET common_desktopdirectory_str
        dd CSIDL_APPDATA,OFFSET appdata_str
        dd CSIDL_PRINTHOOD,OFFSET printhood_str
        dd CSIDL_LOCAL_APPDATA,OFFSET local_appdata_str
        dd CSIDL_ALTSTARTUP,OFFSET altstartup_str
        dd CSIDL_COMMON_ALTSTARTUP,OFFSET common_altstartup_str
        dd CSIDL_COMMON_FAVORITES,OFFSET common_favorites_str
        dd CSIDL_INTERNET_CACHE,OFFSET internet_cache_str
        dd CSIDL_COOKIES,OFFSET cookies_str
        dd CSIDL_HISTORY,OFFSET history_str
        dd CSIDL_COMMON_APPDATA,OFFSET common_appdata_str
        dd CSIDL_WINDOWS,OFFSET windows_str
        dd CSIDL_SYSTEM,OFFSET system_str
        dd CSIDL_PROGRAM_FILES,OFFSET program_files_str
        dd CSIDL_MYPICTURES,OFFSET mypictures_str
        dd CSIDL_PROFILE,OFFSET profile_str
        dd CSIDL_SYSTEMX86,OFFSET systemx86_str
        dd CSIDL_PROGRAM_FILES_COMMON,OFFSET program_files_common_str
        dd CSIDL_COMMON_TEMPLATES,OFFSET common_templates_str
        dd CSIDL_COMMON_DOCUMENTS,OFFSET common_documents_str
        dd CSIDL_COMMON_ADMINTOOLS,OFFSET common_admintools_str
        dd CSIDL_ADMINTOOLS,OFFSET admintools_str
        dd CSIDL_CONNECTIONS,OFFSET connections_str
        dd CSIDL_COMMON_MUSIC,OFFSET common_music_str
        dd CSIDL_COMMON_PICTURES,OFFSET common_pictures_str
        dd CSIDL_COMMON_VIDEO,OFFSET common_video_str
        dd CSIDL_RESOURCES,OFFSET resources_str
        dd CSIDL_RESOURCES_LOCALIZED,OFFSET resources_localized_str
        dd CSIDL_COMMON_OEM_LINKS,OFFSET common_oem_links_str
        dd CSIDL_CDBURN_AREA,OFFSET cdburn_area_str
        dd CSIDL_COMPUTERSNEARME,OFFSET computersnearme_str
        dd CSIDL_PROFILES,OFFSET profiles_str
        dd -1,-1

desktop_str                     db "CSIDL_DESKTOP",0
internet_str                    db "CSIDL_INTERNET",0
programs_str                    db "CSIDL_PROGRAMS",0
controls_str                    db "CSIDL_CONTROLS",0
printers_str                    db "CSIDL_PRINTERS",0
personal_str                    db "CSIDL_PERSONAL",0
favorites_str                   db "CSIDL_FAVORITES",0
startup_str                     db "CSIDL_STARTUP",0
recent_str                      db "CSIDL_RECENT",0
sendto_str                      db "CSIDL_SENDTO",0
bitbucket_str                   db "CSIDL_BITBUCKET",0
startmenu_str                   db "CSIDL_STARTMENU",0
mydocuments_str                 db "CSIDL_MYDOCUMENTS",0
mymusic_str                     db "CSIDL_MYMUSIC",0
myvideo_str                     db "CSIDL_MYVIDEO",0
desktopdirectory_str            db "CSIDL_DESKTOPDIRECTORY",0
drives_str                      db "CSIDL_DRIVES",0
network_str                     db "CSIDL_NETWORK",0
nethood_str                     db "CSIDL_NETHOOD",0
fonts_str                       db "CSIDL_FONTS",0
templates_str                   db "CSIDL_TEMPLATES",0
common_startmenu_str            db "CSIDL_COMMON_STARTMENU",0
common_programs_str             db "CSIDL_COMMON_PROGRAMS",0
common_startup_str              db "CSIDL_COMMON_STARTUP",0
common_desktopdirectory_str     db "CSIDL_COMMON_DESKTOPDIRECTORY",0
appdata_str                     db "CSIDL_APPDATA",0
printhood_str                   db "CSIDL_PRINTHOOD",0
local_appdata_str               db "CSIDL_LOCAL_APPDATA",0
altstartup_str                  db "CSIDL_ALTSTARTUP",0
common_altstartup_str           db "CSIDL_COMMON_ALTSTARTUP",0
common_favorites_str            db "CSIDL_COMMON_FAVORITES",0
internet_cache_str              db "CSIDL_INTERNET_CACHE",0
cookies_str                     db "CSIDL_COOKIES",0
history_str                     db "CSIDL_HISTORY",0
common_appdata_str              db "CSIDL_COMMON_APPDATA",0
windows_str                     db "CSIDL_WINDOWS",0
system_str                      db "CSIDL_SYSTEM",0
program_files_str               db "CSIDL_PROGRAM_FILES",0
mypictures_str                  db "CSIDL_MYPICTURES",0
profile_str                     db "CSIDL_PROFILE",0
systemx86_str                   db "CSIDL_SYSTEMX86",0
program_files_common_str        db "CSIDL_PROGRAM_FILES_COMMON",0
common_templates_str            db "CSIDL_COMMON_TEMPLATES",0
common_documents_str            db "CSIDL_COMMON_DOCUMENTS",0
common_admintools_str           db "CSIDL_COMMON_ADMINTOOLS",0
admintools_str                  db "CSIDL_ADMINTOOLS",0
connections_str                 db "CSIDL_CONNECTIONS",0
common_music_str                db "CSIDL_COMMON_MUSIC",0
common_pictures_str             db "CSIDL_COMMON_PICTURES",0
common_video_str                db "CSIDL_COMMON_VIDEO",0
resources_str                   db "CSIDL_RESOURCES",0
resources_localized_str         db "CSIDL_RESOURCES_LOCALIZED",0
common_oem_links_str            db "CSIDL_COMMON_OEM_LINKS",0
cdburn_area_str                 db "CSIDL_CDBURN_AREA",0
computersnearme_str             db "CSIDL_COMPUTERSNEARME",0
profiles_str                    db "CSIDL_PROFILES",0

strval  db " = ""%s""",0
nl      db 13,10,0

.data?
hStdOut     HANDLE  ?
chWritten   DWORD   ?
ppidl       DWORD   ?
thepath     db 320 dup (?)
buff        db 320 dup (?)

.code
start:
    push esi
    push edi
    invoke GetStdHandle, STD_OUTPUT_HANDLE
    mov hStdOut,eax
    mov esi,OFFSET buff
    mov edi,OFFSET listy

  @@:
    mov eax,DWORD PTR [edi]
    cmp eax,-1
    je @out

    invoke SHGetSpecialFolderLocation, NULL,eax,ADDR ppidl
    cmp eax,NOERROR
    jne @next

    mov eax,[edi+4]
    push eax
    invoke lstrlen, eax
    pop ecx
    invoke WriteFile, hStdOut,ecx,eax,ADDR chWritten,NULL

    ;invoke SHGetSpecialFolderPath, NULL,ADDR thepath,?,FALSE
    invoke SHGetPathFromIDList, ppidl,ADDR thepath
    test eax,eax
    jz @nopath

    invoke wsprintf, esi,ADDR strval,ADDR thepath
    invoke WriteFile, hStdOut,esi,eax,ADDR chWritten,NULL

  @nopath:
    invoke CoTaskMemFree, ppidl
    invoke WriteFile, hStdOut,ADDR nl,2,ADDR chWritten,NULL

  @next:
    add edi,8
    jmp @B

  @out:
    pop edi
    pop esi
    invoke ExitProcess, NULL
end start
