;;those marked with * are valid, but have no filesystem folder

CSIDL_DESKTOP                   equ 00h     ; 98 xp        "C:\Documents and Settings\user\Desktop"
CSIDL_INTERNET                  equ 01h     ;*98 xp
CSIDL_PROGRAMS                  equ 02h     ; 98 xp        "C:\Documents and Settings\user\Start Menu\Programs"
CSIDL_CONTROLS                  equ 03h     ;*98 xp
CSIDL_PRINTERS                  equ 04h     ;*98 xp
CSIDL_PERSONAL                  equ 05h     ; 98 xp        "C:\Documents and Settings\user\My Documents"
CSIDL_FAVORITES                 equ 06h     ; 98 xp        "C:\Documents and Settings\user\Favorites"
CSIDL_STARTUP                   equ 07h     ; 98 xp        "C:\Documents and Settings\user\Start Menu\Programs\Startup"
CSIDL_RECENT                    equ 08h     ; 98 xp        "C:\Documents and Settings\user\Recent"
CSIDL_SENDTO                    equ 09h     ; 98 xp        "C:\Documents and Settings\user\SendTo"
CSIDL_BITBUCKET                 equ 0Ah     ;*98 xp
CSIDL_STARTMENU                 equ 0Bh     ; 98 xp        "C:\Documents and Settings\user\Start Menu"
CSIDL_MYDOCUMENTS               equ 0Ch
CSIDL_MYMUSIC                   equ 0Dh     ;    xp        "C:\Documents and Settings\user\My Documents\My Music"
CSIDL_MYVIDEO                   equ 0Eh

CSIDL_DESKTOPDIRECTORY          equ 10h     ; 98 xp        "C:\Documents and Settings\user\Desktop"
CSIDL_DRIVES                    equ 11h     ;*98 xp
CSIDL_NETWORK                   equ 12h     ;*98 xp
CSIDL_NETHOOD                   equ 13h     ; 98 xp        "C:\Documents and Settings\user\NetHood"
CSIDL_FONTS                     equ 14h     ; 98 xp        "C:\WINDOWS\Fonts"
CSIDL_TEMPLATES                 equ 15h     ; 98 xp        "C:\Documents and Settings\user\Templates"
CSIDL_COMMON_STARTMENU          equ 16h     ;    xp        "C:\Documents and Settings\All Users\Start Menu"
CSIDL_COMMON_PROGRAMS           equ 17h     ;    xp        "C:\Documents and Settings\All Users\Start Menu\Programs"
CSIDL_COMMON_STARTUP            equ 18h     ;    xp        "C:\Documents and Settings\All Users\Start Menu\Programs\Startup"
CSIDL_COMMON_DESKTOPDIRECTORY   equ 19h     ;    xp        "C:\Documents and Settings\All Users\Desktop"
CSIDL_APPDATA                   equ 1Ah     ; 98 xp        "C:\Documents and Settings\user\Application Data"
CSIDL_PRINTHOOD                 equ 1Bh     ; 98 xp        "C:\Documents and Settings\user\PrintHood"
CSIDL_LOCAL_APPDATA             equ 1Ch     ;    xp        "C:\Documents and Settings\user\Local Settings\Application Data"
CSIDL_ALTSTARTUP                equ 1Dh
CSIDL_COMMON_ALTSTARTUP         equ 1Eh
CSIDL_COMMON_FAVORITES          equ 1Fh     ;    xp        "C:\Documents and Settings\All Users\Favorites"

CSIDL_INTERNET_CACHE            equ 20h     ; 98 xp        "C:\Documents and Settings\user\Local Settings\Temporary Internet Files"
CSIDL_COOKIES                   equ 21h     ; 98 xp        "C:\Documents and Settings\user\Cookies"
CSIDL_HISTORY                   equ 22h     ; 98 xp        "C:\Documents and Settings\user\Local Settings\History"
CSIDL_COMMON_APPDATA            equ 23h     ;    xp        "C:\Documents and Settings\All Users\Application Data"
CSIDL_WINDOWS                   equ 24h     ;    xp        "C:\WINDOWS"
CSIDL_SYSTEM                    equ 25h     ;    xp        "C:\WINDOWS\system32"
CSIDL_PROGRAM_FILES             equ 26h     ;    xp        "C:\Program Files"
CSIDL_MYPICTURES                equ 27h
CSIDL_PROFILE                   equ 28h     ;    xp        "C:\Documents and Settings\user"
CSIDL_SYSTEMX86                 equ 29h     ;    xp        "C:\WINDOWS\system32"
CSIDL_PROGRAM_FILES_COMMON      equ 2Bh     ;    xp        "C:\Program Files\Common Files"
CSIDL_COMMON_TEMPLATES          equ 2Dh     ;    xp        "C:\Documents and Settings\All Users\Templates"
CSIDL_COMMON_DOCUMENTS          equ 2Eh
CSIDL_COMMON_ADMINTOOLS         equ 2Fh     ;    xp        "C:\Documents and Settings\All Users\Start Menu\Programs\Administrative Tools"

CSIDL_ADMINTOOLS                equ 30h
CSIDL_CONNECTIONS               equ 31h     ;*   xp
CSIDL_COMMON_MUSIC              equ 35h
CSIDL_COMMON_PICTURES           equ 36h
CSIDL_COMMON_VIDEO              equ 37h
CSIDL_RESOURCES                 equ 38h     ;    xp        "C:\WINDOWS\Resources"
CSIDL_RESOURCES_LOCALIZED       equ 39h
CSIDL_COMMON_OEM_LINKS          equ 3Ah
CSIDL_CDBURN_AREA               equ 3Bh     ;    xp        "C:\Documents and Settings\user\Local Settings\Application Data\Microsoft\CD Burning"
CSIDL_COMPUTERSNEARME           equ 3Dh
CSIDL_PROFILES                  equ 3Eh

CSIDL_FLAG_PER_USER_INIT        equ 0800h
CSIDL_FLAG_NO_ALIAS             equ 1000h
CSIDL_FLAG_DONT_VERIFY          equ 4000h
CSIDL_FLAG_CREATE               equ 8000h
;CSIDL_FLAG_MASK                 equ 0FF00h